| Linduino 1.3.0 Linear Technology Arduino-Compatible Demonstration Board

Functions
LTC3676.cpp File Reference

LTC3676: Power management solution for application processors. More...

## Detailed Description

LTC3676: Power management solution for application processors.

    The LTC3676 is a complete power management solution for advanced portable
    application processor-based systems. The device contains four synchronous
    step-down DC/DC converters for core, memory, I/O, and system on-chip (SoC)
    rails and three 300mA LDO regulators for low noise analog supplies. The
    LTC3676-1 has a 1.5A buck regulator configured to support DDR termination
    plus a VTTR reference output. An I2C serial port is used to control regulator
    enables, power-down sequencing, output voltage levels, dynamic voltage
    scaling, operating modes and status reporting.
    Regulator start-up is sequenced by connecting outputs to enable pins in the
    desired order or via the I2C port. System power-on, power-off and reset
    functions are controlled by pushbutton interface, pin inputs, or I2C.
    The LTC3676 supports i.MX, PXA and OMAP processors with eight independent
    rails at appropriate power levels. Other features include interface signals
    such as the VSTB pin that toggles between programmed run and standby output
    voltages on up to four rails simultaneously. The device is available in a
    40-lead 6mm x 6mm QFN package.

    I2C DATA FORMAT (MSB FIRST);

http://www.linear.com/product/LTC3676

http://www.linear.com/product/LTC3676#demoboards

Copyright 2018(c) Analog Devices, Inc.

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
- Neither the name of Analog Devices, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
- The use of this software may or may not infringe the patent rights of one or more patent holders. This license does not release you from the requirement that you obtain separate licenses from these patent holders to use this software.
- Use of the software either in source or binary form, must be run on or directly connected to an Analog Devices Inc. component.

THIS SOFTWARE IS PROVIDED BY ANALOG DEVICES "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, NON-INFRINGEMENT, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL ANALOG DEVICES BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, INTELLECTUAL PROPERTY RIGHTS, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Library for LTC3676: Power management solution for application processors

Definition in file LTC3676.cpp.

Go to the source code of this file.

## Functions
int8_t | LTC3676_register_read (uint8_t i2c_address, uint8_t register_address, uint8_t *register_data)
| Reads an 8-bit register from the LTC3676 using the standard repeated start format. More...
int8_t | LTC3676_register_write (uint8_t i2c_address, uint8_t register_address, uint8_t register_data)
| Writes to an 8-bit register inside the LTC3676 using the standard I2C repeated start format. More...
int8_t | LTC3676_bit_set (uint8_t i2c_address, uint8_t register_address, uint8_t bit_number)
| Sets any bit inside the LTC3676 using the standard I2C repeated start format. More...
int8_t | LTC3676_bit_clear (uint8_t i2c_address, uint8_t register_address, uint8_t bit_number)
| Clears any bit inside the LTC3676 using the standard I2C repeated start format. More...
int8_t | LTC3676_bit_write (uint8_t i2c_address, uint8_t register_address, uint8_t bit_number, uint8_t bit_data)
| Writes any bit inside the LTC3676 using the standard I2C repeated start format. More...
uint8_t | LTC3676_bit_is_set (uint8_t i2c_address, uint8_t register_address, uint8_t bit_number)
| Reads the value of any bit in any register or the LTC3676. More...
float | LTC3676_set_buck_output_voltage (uint8_t i2c_address, uint8_t register_address, float output_voltage)
| Sets the output voltage of any buck. More...
float | LTC3676_set_buck_fb_ref (uint8_t i2c_address, uint8_t register_address, float fb_ref_voltage)
| Writes the Feedback Reference Voltage of any buck. More...
float | LTC3676_buck_vout_max (uint8_t buck_number)
| Calculates the maximum output voltage of any buck in mV based on the feedback resistors. More...
float | LTC3676_buck_vout_min (uint8_t buck_number)
| Calculates the minimum output voltage of any buck in mV based on the feedback resistors. More...
int8_t | LTC3676_select_buck_reference (uint8_t i2c_address, uint8_t buck_number, int8_t ref_char)
| Selects the reference for the specified buck regulator(s). More...
int8_t | LTC3676_set_buck_mode (uint8_t i2c_address, uint8_t buck_number, uint8_t mode)
| Sets the switching mode for the specified Buck regulator. More...
int8_t | LTC3676_set_startup_mode (uint8_t i2c_address, uint8_t buck_number, uint8_t startup_bit)
| Sets the start-up mode for all bucks. More...
int8_t | LTC3676_set_buck_pgood_mask (uint8_t i2c_address, uint8_t buck_number, uint8_t pgood_bit)
| Sets the PGOOD mask bit in the DVBxB register for all bucks. More...
int8_t | LTC3676_set_uv_warning_threshold (uint8_t i2c_address, float uv_warning_threshold)
| Writes a new UV warning threshold voltage in the CTRL register. More...
int8_t | LTC3676_set_overtemp_warning_level (uint8_t i2c_address, uint8_t ot_warning_level)
| Writes the UV warning threshold of any buck. More...
int8_t | LTC3676_1_set_ldo4_voltage (uint8_t i2c_address, uint8_t ldo4_output_voltage_code)
| Sets LDO4 output voltage on the LTC3676-1. More...
int8_t | LTC3676_set_buck_sequence_down (uint8_t i2c_address, uint8_t buck_number, uint8_t sequence_phase)
| Sets the Sequence Down bits for any buck in the SQD1 register. More...
int8_t | LTC3676_set_ldo_sequence_down (uint8_t i2c_address, uint8_t ldo_number, uint8_t sequence_phase)
| Sets the Sequence Down bits for any buck in the SQD1 register. More...

## Function Documentation

## ◆ LTC3676_1_set_ldo4_voltage()

int8_t LTC3676_1_set_ldo4_voltage | ( | uint8_t | i2c_address,
|  | uint8_t | ldo4_output_voltage_code
| ) |  |

Sets LDO4 output voltage on the LTC3676-1.

Returns
  Returns the state of the acknowledge bit after the I2C addresss write. 0=acknowledge, 1=no acknowledge.

Parameters

  i2c_address | I2C address of the LTC3676-1.
  ldo4_output_voltage_code | Voltage code for new LDO4 output voltage: 0=1.2V, 1=2.5V, 2=2.8V, 3=3.0V

Definition at line 341 of file LTC3676.cpp.

## ◆ LTC3676_bit_clear()

int8_t LTC3676_bit_clear | ( | uint8_t | i2c_address,
|  | uint8_t | register_address,
|  | uint8_t | bit_number
| ) |  |

Clears any bit inside the LTC3676 using the standard I2C repeated start format.

Returns
  Returns the state of the acknowledge bit after the I2C address write. 0=acknowledge, 1=no acknowledge.

Parameters

  i2c_address | I2C address of the LTC3676.
  register_address | Address of the LTC3676 register to be overwritten. This is also known as the "command byte".
  bit_number | Address of the bit to set within the register.

Definition at line 108 of file LTC3676.cpp.

## ◆ LTC3676_bit_is_set()

uint8_t LTC3676_bit_is_set | ( | uint8_t | i2c_address,
|  | uint8_t | register_address,
|  | uint8_t | bit_number
| ) |  |

Reads the value of any bit in any register or the LTC3676.

Returns
  Returns the bit value at the passed register subaddress and bit location.

Parameters

  i2c_address | I2C address of the LTC3676.
  register_address | Address of the LTC3676 register to be read. This is also known as the "command byte".
  bit_number | Bit location (0-7) to be read.

Definition at line 137 of file LTC3676.cpp.

## ◆ LTC3676_bit_set()

int8_t LTC3676_bit_set | ( | uint8_t | i2c_address,
|  | uint8_t | register_address,
|  | uint8_t | bit_number
| ) |  |

Sets any bit inside the LTC3676 using the standard I2C repeated start format.

Returns
  Returns the state of the acknowledge bit after the I2C address write. 0=acknowledge, 1=no acknowledge.

Parameters

  i2c_address | I2C address of the LTC3676.
  register_address | Address of the LTC3676 register to be overwritten. This is also known as the "command byte".
  bit_number | Bit location (0-7) to be written.

Definition at line 95 of file LTC3676.cpp.

## ◆ LTC3676_bit_write()

int8_t LTC3676_bit_write | ( | uint8_t | i2c_address,
|  | uint8_t | register_address,
|  | uint8_t | bit_number,
|  | uint8_t | bit_data
| ) |  |

Writes any bit inside the LTC3676 using the standard I2C repeated start format.

Returns
  Returns the state of the acknowledge bit after the I2C address write. 0=acknowledge, 1=no acknowledge.

Parameters

  i2c_address | I2C address of the LTC3676.
  register_address | Address of the LTC3676 register to be written.
  bit_number | Bit location (0-7) to be written.
  bit_data | Bit data (0 or 1) to be written.

Definition at line 122 of file LTC3676.cpp.

## ◆ LTC3676_buck_vout_max()

float LTC3676_buck_vout_max | ( | uint8_t | buck_number | ) |

Calculates the maximum output voltage of any buck in mV based on the feedback resistors.

Returns
  Returns the maximum possible output voltage for the selected buck.

Parameters

  buck_number | Number (1-4) of buck.

Definition at line 191 of file LTC3676.cpp.

## ◆ LTC3676_buck_vout_min()

float LTC3676_buck_vout_min | ( | uint8_t | buck_number | ) |

Calculates the minimum output voltage of any buck in mV based on the feedback resistors.

Returns
  Returns the minimum possible output voltage for the selected buck.

Parameters

  buck_number | Number (1-4) of buck.

Definition at line 212 of file LTC3676.cpp.

## ◆ LTC3676_register_read()

int8_t LTC3676_register_read | ( | uint8_t | i2c_address,
|  | uint8_t | register_address,
|  | uint8_t * | register_data
| ) |  |

Reads an 8-bit register from the LTC3676 using the standard repeated start format.

Returns
  Returns the state of the acknowledge bit after the I2C address write. 0=acknowledge, 1=no acknowledge.

Parameters

  i2c_address | I2C address of the LTC3676.
  register_address | Address of the LTC3676 register to be read. This is also known as the "command byte".
  register_data | returns 8-bit value read from the LTC3676 register.

Definition at line 78 of file LTC3676.cpp.

## ◆ LTC3676_register_write()

int8_t LTC3676_register_write | ( | uint8_t | i2c_address,
|  | uint8_t | register_address,
|  | uint8_t | register_data
| ) |  |

Writes to an 8-bit register inside the LTC3676 using the standard I2C repeated start format.

Returns
  Returns the state of the acknowledge bit after the I2C address write. 0=acknowledge, 1=no acknowledge.

Parameters

  i2c_address | I2C address of the LTC3676.
  register_address | Address of the LTC3676 register to be overwritten. This is also known as the "command byte".
  register_data | Value that will be written to the register.

Definition at line 86 of file LTC3676.cpp.

## ◆ LTC3676_select_buck_reference()

int8_t LTC3676_select_buck_reference | ( | uint8_t | i2c_address,
|  | uint8_t | buck_number,
|  | int8_t | ref_char
| ) |  |

Selects the reference for the specified buck regulator(s).

Returns
  Returns the state of the acknowledge bit after the I2C addresss write. 0=acknowledge, 1=no acknowledge.

Parameters

  i2c_address | I2C address of the LTC3676.
  buck_number | Number (1-4) of the buck whose reference will be selected. Enter 0xFF for all bucks.
  ref_char | Reference to select (A or B).

Definition at line 233 of file LTC3676.cpp.

## ◆ LTC3676_set_buck_fb_ref()

float LTC3676_set_buck_fb_ref | ( | uint8_t | i2c_address,
|  | uint8_t | register_address,
|  | float | fb_ref_voltage
| ) |  |

Writes the Feedback Reference Voltage of any buck.

Returns
  Returns the new Feedback Reference Input Voltage, the closest allowable voltage to the user's chosen voltage.

Parameters

  i2c_address | I2C address of the LTC3676.
  register_address | Address of the LTC3676 Buck FB reference register to be written.
  fb_ref_voltage | New Feedback Reference voltage to set in mV. Values between 412.5 and 800 are allowed.

Definition at line 176 of file LTC3676.cpp.

## ◆ LTC3676_set_buck_mode()

int8_t LTC3676_set_buck_mode | ( | uint8_t | i2c_address,
|  | uint8_t | buck_number,
|  | uint8_t | mode
| ) |  |

Sets the switching mode for the specified Buck regulator.

Returns
  Returns the state of the acknowledge bit after the I2C addresss write. 0=acknowledge, 1=no acknowledge.

Parameters

  i2c_address | I2C address of the LTC3676.
  buck_number | Number (1-4) of the buck to set. Enter 0xFF for all bucks.
  mode | Switching mode to be set (0=pulse skipping, 1=burst, 2=forced continuous)

Definition at line 255 of file LTC3676.cpp.

## ◆ LTC3676_set_buck_output_voltage()

float LTC3676_set_buck_output_voltage | ( | uint8_t | i2c_address,
|  | uint8_t | register_address,
|  | float | output_voltage
| ) |  |

Sets the output voltage of any buck.

Returns
  Returns the new buck output voltage, the closest allowable voltage to the user's chosen voltage.

Parameters

  i2c_address | I2C address of the LTC3676.
  register_address | Address of the LTC3676 Buck FB reference register to be written.
  output_voltage | New output voltage to set, in mV. Assumes a valid voltage for the feedback resistors.

Definition at line 147 of file LTC3676.cpp.

## ◆ LTC3676_set_buck_pgood_mask()

int8_t LTC3676_set_buck_pgood_mask | ( | uint8_t | i2c_address,
|  | uint8_t | buck_number,
|  | uint8_t | pgood_bit
| ) |  |

Sets the PGOOD mask bit in the DVBxB register for all bucks.

Returns
  Returns the state of the acknowledge bit after the I2C addresss write. 0=acknowledge, 1=no acknowledge.

Parameters

  i2c_address | I2C address of the LTC3676.
  buck_number | Number (1-4) of the buck to set.
  pgood_bit | Data to write to PGOOD bit (0=PGOOD low when slewing, 1=PGOOD not forced low when slewing)

Definition at line 293 of file LTC3676.cpp.

## ◆ LTC3676_set_buck_sequence_down()

int8_t LTC3676_set_buck_sequence_down | ( | uint8_t | i2c_address,
|  | uint8_t | buck_number,
|  | uint8_t | sequence_phase
| ) |  |

Sets the Sequence Down bits for any buck in the SQD1 register.

Returns
  Returns the state of the acknowledge bit after the I2C address write. 0=acknowledge, 1=no acknowledge.

Parameters

  i2c_address | I2C address of the LTC3676.
  buck_number | Number (1-4) of the buck to sequence.
  sequence_phase | Sequence down phase: 0=with WAKE, 1=WAKE+100ms, 2=WAKE+200ms, 3=WAKE+300ms.

Definition at line 354 of file LTC3676.cpp.

## ◆ LTC3676_set_ldo_sequence_down()

int8_t LTC3676_set_ldo_sequence_down | ( | uint8_t | i2c_address,
|  | uint8_t | ldo_number,
|  | uint8_t | sequence_phase
| ) |  |

Sets the Sequence Down bits for any buck in the SQD1 register.

Returns
  Returns the state of the acknowledge bit after the I2C address write. 0=acknowledge, 1=no acknowledge.

Parameters

  i2c_address | I2C address of the LTC3676.
  ldo_number | Number (2-4) of the LDO to sequence.
  sequence_phase | Sequence down phase: 0=with WAKE, 1=WAKE+100ms, 2=WAKE+200ms, 3=WAKE+300ms.

Definition at line 368 of file LTC3676.cpp.

## ◆ LTC3676_set_overtemp_warning_level()

int8_t LTC3676_set_overtemp_warning_level | ( | uint8_t | i2c_address,
|  | uint8_t | ot_warning_level
| ) |  |

Writes the UV warning threshold of any buck.

Returns
  Returns the state of the acknowledge bit after the I2C addresss write. 0=acknowledge, 1=no acknowledge.

Parameters

  i2c_address | I2C address of the LTC3676.
  ot_warning_level | New overtemp warning level to set, degrees C below Overtemperature fault level. Values 10, 20, 30, and 40 are allowed.

Definition at line 326 of file LTC3676.cpp.

## ◆ LTC3676_set_startup_mode()

int8_t LTC3676_set_startup_mode | ( | uint8_t | i2c_address,
|  | uint8_t | buck_number,
|  | uint8_t | startup_bit
| ) |  |

Sets the start-up mode for all bucks.

Returns
  Returns the state of the acknowledge bit after the I2C addresss write. 0=acknowledge, 1=no acknowledge.

Parameters

  i2c_address | I2C address of the LTC3676.
  buck_number | Number (1-4) of the buck to set. Enter 0xFF for all bucks.
  startup_bit | Data to write to start-up bit (0=enable at any output, 1=enable only if output <300mV)

Definition at line 276 of file LTC3676.cpp.

## ◆ LTC3676_set_uv_warning_threshold()

int8_t LTC3676_set_uv_warning_threshold | ( | uint8_t | i2c_address,
|  | float | uv_warning_threshold
| ) |  |

Writes a new UV warning threshold voltage in the CTRL register.

Returns
  Returns the state of the acknowledge bit after the I2C addresss write. 0=acknowledge, 1=no acknowledge.

Parameters

  i2c_address | I2C address of the LTC3676.
  uv_warning_threshold | New UV warning threshold to set, in volts. Values between 2.7 and 3.4 are allowed.

Definition at line 311 of file LTC3676.cpp.